"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.PostgresEventAlreadyExistsError = void 0;

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _wrapNativeSuper2 = _interopRequireDefault(require("@babel/runtime/helpers/wrapNativeSuper"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _core = require("@castore/core");

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var PostgresEventAlreadyExistsError = /*#__PURE__*/function (_Error) {
  (0, _inherits2["default"])(PostgresEventAlreadyExistsError, _Error);

  var _super = _createSuper(PostgresEventAlreadyExistsError);

  function PostgresEventAlreadyExistsError(_ref) {
    var _this;

    var _ref$eventStoreId = _ref.eventStoreId,
        eventStoreId = _ref$eventStoreId === void 0 ? '' : _ref$eventStoreId,
        aggregateId = _ref.aggregateId,
        version = _ref.version;
    (0, _classCallCheck2["default"])(this, PostgresEventAlreadyExistsError);
    _this = _super.call(this, "Event already exists for ".concat(eventStoreId, " aggregate ").concat(aggregateId, " and version ").concat(version));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "code", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "eventStoreId", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "aggregateId", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "version", void 0);
    _this.code = _core.eventAlreadyExistsErrorCode;

    if (eventStoreId) {
      _this.eventStoreId = eventStoreId;
    }

    _this.aggregateId = aggregateId;
    _this.version = version;
    return _this;
  }

  return (0, _createClass2["default"])(PostgresEventAlreadyExistsError);
}( /*#__PURE__*/(0, _wrapNativeSuper2["default"])(Error));

exports.PostgresEventAlreadyExistsError = PostgresEventAlreadyExistsError;
//# sourceMappingURL=error.js.map